#include <avr/io.h>
#include <util/delay.h>

#define F_CPU 16000000
#define SPEED 250
#define SPEED2 150
#define RIGHT  1
#define LEFT 2
#define UP 3
#define BLOCK 4
#define N 8
#define NO -1

int a, b, c, d;

void init (){
	
	PORTA = 0xff;
	DDRA = 0x00;
	
	OCR1A = 0;
	OCR1B = 0;
	OCR2A = 0;
	OCR2B = 0;
	
	PORTD |= (1 << PD4) | (1 << PD5) | (1 << PD6) | (1 << PD7);
	DDRD |= (1 << PD4) | (1 << PD5) | (1 << PD6) | (1 << PD7);

	TCCR1A &= 0x00;
	TCCR1A |= (1 << WGM10) | (1 << WGM11);
	TCCR1B &= 0x00;
	TCCR1B |= (1 << CS10);
	
	TCCR2A &= 0x00;
	TCCR2A |= (1<<WGM20) | (1<<WGM21)  | (1<<COM2A1) | (1<<COM2B1);
	TCCR2B &= 0x00;
	TCCR2B |=  (1<<CS21);
	
}

void miscare (int directie,int viteza){

	switch(directie){
		case BLOCK:	OCR1B = a;
					OCR1A = b;
					OCR2B = c;
					OCR2A = d;
					break;
		case RIGHT:
					a = OCR1B = 0;
					b = OCR1A = 0;
					c = OCR2B = viteza;
					d = OCR2A = 0;
					break;
		case LEFT:
					a = OCR1B = viteza;
					b = OCR1A = 0;
					c = OCR2B = 0;
					d = OCR2A = 0;
					break;
		case UP:
					a = OCR1B = viteza;
					b = OCR1A = 0;
					c = OCR2B = viteza;
					d = OCR2A = 0;
					break;
	}
	
}

int main(){

	int left,right,i,d;
	unsigned char sensors;
	
	init ();

	while (1) {
	
		sensors = PINA;
		left = NO;
		right = NO;
		
		for (i = 0; i < N; i++) {
			if (bit_is_set (sensors, i) && left == NO)
					left = i;
		}

		for (i = N - 1; i >= 0; i--) {
			if (bit_is_set (sensors, i) && right == NO)
					right = i;
		}
	
		if (left + right == 2*NO) {
			miscare (BLOCK, SPEED);
		}else{
			d = right - left;
			if (left > 3 + d/2 ) {
				miscare (LEFT, SPEED2 + left * 10);
			}else{
				if (right < 4 - d/2) {
					miscare (RIGHT, SPEED2 + (N - 1 - right) * 10);
				}else{
				miscare (UP, SPEED);
				}
			}
		}
	}
	
	return 0;
}
